<?
# Galeras II - DMI-Gal rewrite from scratch
# Module: Thumbnails
# gal-thumbs.inc 
# Derechos Reservados (c) 2003 Sandino Araico Snchez
# Derechos Reservados (c) 2003 Presidencia de la Repblica
# Copyright (c) 2003 Sandino Araico Snchez All rights reserved
/*
 * --COMIENZA LICENCIA EN ESPAOL MEXICANO-------------------------------------
 * Por ste medio se otroga permiso, libre de cargo, a cualquier persona que
 * obtenga una copia de este software y archivos de documentacin asociados
 * (el "Software"), a utilizar el Software sin restriccin, incluyendo sin 
 * limitacin los derechos de usar, copiar, modificar, unir, publicar, 
 * distribuir y/o vender copias de el Software, y permitir lo mismo a personas 
 * a quienes les sea entregado el software, siempre y cuando los avisos de 
 * Derechos reservados y Copyright que aparecen arriba y ste permiso (en 
 * espaol y en ingls) aparezcan en todas las copias de el Software y que 
 * tanto los avisos de Derechos reservados y Copyright que aparecen arriba como
 * ste permiso (en espaol y en ingls) aparezcan en la documentacin de
 * soporte.
 *
 * ESTE SOFTWARE SE PROVEE "TAL CUAL", SIN NINGUNA GARANTA DE NINGN TIPO,
 * EXPRESA O IMPLCITA, INCLUYENDO PERO NO LIMITNDOSE A LAS GARANTAS DE
 * MERCANTIBILIDAD, ADECUACIN PARA UN PROPSITO EN PARTICULAR Y NO 
 * INFRACCIN DE LOS DERECHOS DE TERCERAS PARTES. EN NINGN MOMENTO EL O LOS 
 * TITULARES DE LOS DERECHOS DE AUTOR Y COPYRIGHT INCLUIDOS EN ESTE AVISO SERN
 * RESPONSABLES POR CUALQUIER RECLAMACIN O POR CUALQUIER DAO ESPECIAL,
 * INDIRECTO O CONSECUENTE, O CUALQUIER DAO QUE RESULTE DE LA PRDIDA DE USO,
 * DATOS O GANANCIAS, YA SEA EN UNA ACCIN DE CONTRATO, NEGLIGENCIA U OTRA 
 * ACCIN TORTUORIA, RESULTANTE DE O EN CONEXIN CON EL USO O DESEMPEO DE
 * ESTE SOFTWARE.
 *
 * Excepto que se incluya en ste aviso, no se debe usar el nombre de ningn 
 * titular de Derechos de autor o Copyright en publicidad o de otra manera 
 * psra promover la venta, uso u otros tratos en este Software sin previa 
 * autorizacin por escrito del titular de Derechos de autor o Copyright.
 * --TERMINA LICENCIA----------------------------------------------------------
 *
 * --BEGIN LICENSE IN US ENGLISH-----------------------------------------------
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the
 * "Software"), to deal in the Software without restriction, including
 * without limitation the rights to use, copy, modify, merge, publish,
 * distribute, and/or sell copies of the Software, and to permit persons
 * to whom the Software is furnished to do so, provided that the above
 * copyright and "Derechos reservados" notices and this permission notice  
 * (in spanish and english) appear in all copies of the Software and that both 
 * the above copyright and "Derechos reservados" notices and this permission 
 * notice (in spanish and english) appear in supporting documentation.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
 * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT
 * OF THIRD PARTY RIGHTS. IN NO EVENT SHALL THE COPYRIGHT AND "DERECHOS DE 
 * AUTOR" HOLDER OR HOLDERS INCLUDED IN THIS NOTICE BE LIABLE FOR ANY CLAIM, OR 
 * ANY SPECIAL INDIRECT OR CONSEQUENTIAL DAMAGES, OR ANY DAMAGES WHATSOEVER 
 * RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF 
 * CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN 
 * CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 * 
 * Except as contained in this notice, the name of a copyright or "Derechos de
 * autor" holder shall not be used in advertising or otherwise to promote the
 * sale, use or other dealings in this Software without prior written 
 * authorization of the copyright or "Derechos de autor" holder.
 * --END LICENSE---------------------------------------------------------------
 */
 
# Changelog: 
# 2003-02-04 Sandino Araico Snchez - Moved Thumbnails functions from gal-objects
# 2003-02-05 Sandino Araico Snchez - Thumbnail creation and delivery
#	Default thumbnails				Common extension
#	Error handling					Size considerations
#	Mime-based drivers				Image Magick resizer
#	Embeddable thumbnail function		Defaults management


if(!defined('__GAL_THUMBNAILS__'))
{
	define('__GAL_THUMBNAILS__',1);
#---------------------------------------------------------------------
include __HOPP_INCLUDE_PATH.'cache/cache-basic.inc';
include __HOPP_INCLUDE_PATH.'mime.inc';
include __HOPP_INCLUDE_PATH.'fs.inc';
include __HOPP_INCLUDE_PATH.'template.inc';
include 'gal-defaults.inc';
include 'gal-objects.inc';
#---------------------------------------------------------------------
define('__GAL_THUMB_RESULT_DEFAULT','D');
define('__GAL_THUMB_RESULT_ERROR','E');
define('__GAL_THUMB_RESULT_TIME','T');
#---------------------------------------------------------------------
function gal_send_thumb($img_file, $dir, $width=0, $height=0, $template_dir='', $template_prefix='')
{
	if(ereg('^\.\.\/',$img_file))
		return;
	if(empty($width))
		$width=__GAL_THUMB_WIDTH;
	if(empty($height))	
		$height=__GAL_THUMB_HEIGHT;
	if(empty($template_dir))	
		$template_dir=__GAL_TEMPLATE_DIR;
	if(empty($template_prefix))
		$template_prefix=__GAL_TEMPLATE_PREFIX;
		
	$thumb=gal_get_thumb_from_file($img_file,$dir,$width,$height);
	if(is_array($thumb))
	{
		gal_send_image_object($thumb);
		if(__DEBUG__)
			echo "\n\n".s_time_delta()."\n\n"; //Just for debug
		return;
	}
	switch($thumb)
	{
	case __GAL_THUMB_RESULT_ERROR:
		$image=gal_get_thumb_from_template($template_prefix,'error',$template_dir);
		break;
	case __GAL_THUMB_RESULT_TIME:
		$image=gal_get_thumb_from_template($template_prefix,'time',$template_dir);
		break;
	case __GAL_THUMB_RESULT_DEFAULT:
		$image=gal_get_thumb_from_template($template_prefix,'default-thumb',$template_dir);
		break;
	default:
		$image=gal_get_thumb_from_template($template_prefix,'default-thumb',$template_dir);
	}	
	$thumb=gal_get_thumb_from_file($image,'',$width,$height);
	if(!is_array($thumb))
	{
		$image=gal_get_thumb_from_template($template_prefix,'default-thumb',$template_dir);
		$thumb=gal_get_thumb_from_file($image,'',$width,$height);
	}	
	gal_send_image_object($thumb);
}

function gal_get_thumb_from_file($file, $dir, $width, $height, $thumbs_dir=__GAL_THUMBS_DIR, $create=1)
{
	if(empty($file))
		return;
	s_log("Looking for image file: $file");
	if(!file_exists($file))
	{
		if($dir)
			return gal_get_thumb_from_file("$dir/$file", '', $width, $height, $thumbs_dir);
		else
			return;
	}	
	s_log("Found image file: $file");
	s_log("thumbs_dir: $thumbs_dir",0,0,3);	
	$object=h_fs_get_object_from_file($file,$dir,0,'gal_get_extra_object_from_file');
	if(is_array($object))
	{
		if(($width>=$object['IMG_W'])&&($height>=$object['IMG_H']))
			return $object;
		$thumbstring=":Galeras-II:thumbnail:".$object['FILE'].":$width x $height>";
		$thumbs_ext=(defined('__GAL_THUMBS_FORCE_EXT'))?__GAL_THUMBS_FORCE_EXT:$object['EXT'];
		$thumbfile=h_cache_get_file_from_string($thumbstring, $thumbs_dir).'.'.$thumbs_ext;
		s_log("thumbfile: $thumbfile",0,0,3);
		if(!h_fs_check_dir($thumbfile))
			return __GAL_THUMB_RESULT_ERROR;
		if(file_exists($thumbfile))
		{		
			 $thumb_obj=h_fs_get_object_from_file($thumbfile,'',1,'gal_get_extra_object_from_file');	
			 if($create&&is_array($thumb_obj))
			 {
				if($object['MTIME']>$thumb_obj['MTIME'])
					$thumb_obj=gal_create_thumb($object, $thumbfile, $width, $height);
			 }
		}	 
		else	
		{
			if($create)
				$thumb_obj=gal_create_thumb($object, $thumbfile, $width, $height);
			else	
				return __GAL_THUMB_RESULT_ERROR;
		}
		if(is_array($thumb_obj))	
			return $thumb_obj;
		if((strlen($thumb_obj)>1)&&file_exists($thumb_obj))
			return h_fs_get_object_from_file($thumb_obj,'',1,'gal_get_extra_object_from_file');	
		return $thumb_obj;	
	}
}

function gal_send_image_object($object)
{
	if(!is_array($object))
		return;
	//Output to Browser
	if(empty($object['MIME']))
		return;
	header("Content-type: ".$object['MIME']);
	#header("Refresh: 3; URL=$SCRIPT_NAME?GAL_IMG_FILE=$GAL_IMG_FILE"); // test for non-blocking cache
	$file=basename($object['FILE']);
	if($file)
		header("Content-Disposition: attachment; filename=$file");
	if(!file_exists($object['FULL_FILE']))
		return;
	readfile($object['FULL_FILE']);
}

function gal_get_thumb_size_from_file($file, $dir, $width, $height, $thumbs_dir=__GAL_THUMBS_DIR)
{
	if((!$width)||(!$height))
		return;
	$thumb=gal_get_thumb_from_file($file, $dir, $width, $height, $thumbs_dir, 0);
	if(is_array($thumb))
	{
		if($thumb['IMG_SIZE'])
			return $thumb['IMG_SIZE'];
		if($thumb['IMG_W']&&$thumb['IMG_H'])
			return 'width='.$thumb['IMG_W'].' height='.$thumb['IMG_H'];
	}
	$object=h_fs_get_object_from_file($file,$dir,0,'gal_get_extra_object_from_file');
	return gal_get_thumb_size_from_object($object, $width, $height);
}

function gal_get_thumb_size_from_object($object, $width, $height)
{
	if((!$width)||(!$height))
		return;
	if((!$object['IMG_W'])||(!$object['IMG_H']))
		return;
	if(($object['IMG_W']<=$width)&&($object['IMG_H']<=$height))
		return 'width='.$object['IMG_W'].' height='.$object['IMG_H'];
	$wscale=$object['IMG_W']/$width;
	$hscale=$object['IMG_H']/$height;
	if($wscale>$hscale)
		return 'width='.$width.' height='.($object['IMG_H']/$wscale);
	if($hscale>$wscale)	
		return 'width='.($object['IMG_W']/$hscale).' height='.$height;
	return "width=$width height=$height";	
}
#---------------------------------------------------------------------
function gal_create_thumb($object, $thumbfile, $width, $height)
{
	if(!$object['MIME'])
		return __GAL_THUMB_RESULT_DEFAULT;
	$mime=explode('/',$object['MIME']);
	$small_function='gal_create_thumb_from_mime_'.$mime[0];
	$large_function=$small_function.'_'.$mime[1];
	if(function_exists($large_function))
		return $large_function($object, $thumbfile, $width, $height);
	if(function_exists($small_function))
		return $small_function($object, $thumbfile, $width, $height);
	return __GAL_THUMB_RESULT_DEFAULT;	
}

function gal_get_thumb_from_template($template_prefix, $name, $template_dir='')
{
	$default_img_file=h_template_probe_name($template_prefix."-$name",$template_dir,'jpg gif png jpeg');
	s_log("Default Img: $default_img_file - ".strlen($default_img_file),0,0,3);
	//$img_object=h_fs_get_object_from_file($default_img_file, '', 2, 'gal_get_extra_object_from_file');
	//if(is_array($img_object))
	//	return $img_object;
	return $default_img_file;
}
#---------------------------------------------------------------------
// Mime drivers - should go to a different file when too many
function gal_create_thumb_from_mime_image_jpeg($object, $thumbfile, $width, $height)
{
	// Here we must use the native JPEG functions (GD)
	// We can borrow from Acalli 
	s_log('image/jpeg thumbnail driver',0,0,3);
	return gal_create_thumb_from_mime_image($object, $thumbfile, $width, $height);
}

function gal_create_thumb_from_mime_image($object, $thumbfile, $width, $height)
{
	$result=gal_create_thumb_with_Image_Magick($object, $thumbfile, $width, $height);
	if(!$result)
		return __GAL_THUMB_RESULT_ERROR;
	return $thumbfile;	
}

function gal_create_thumb_with_Image_Magick($object, $thumbfile, $width, $height)
{
	$command=__GAL_CONVERT.' -geometry '.$width.'x'.$height.' ';
	$command.=$object['FULL_FILE'].' '.$thumbfile;
	$command=escapeshellcmd($command);
	s_log("command: $command",0,0,3);
	return !`$command`;
}


#---------------------------------------------------------------------
} //__GAL_THUMBNAILS__
?>
